From 93ee954cef607cfefd85484b18e32d1fba225d89 Mon Sep 17 00:00:00 2001
From: Rabin Vincent <rabin@rab.in>
Date: Mon, 28 May 2012 10:58:27 +0530
Subject: [PATCH] fix vtop Section handling

---
 arm.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

diff --git a/arm.c b/arm.c
index 5930c02..4e7b6dc 100644
--- a/arm.c
+++ b/arm.c
@@ -957,12 +957,14 @@ arm_vtop(ulong vaddr, ulong *pgd, physaddr_t *paddr, int verbose)
 			MKSTR((ulong)page_middle)), pmd_pte);
 
 	if ((pmd_pte & PMD_TYPE_MASK) == PMD_TYPE_SECT) {
+		ulong sectionbase = pmd_pte & _SECTION_PAGE_MASK;
+
 		if (verbose) {
 			fprintf(fp, " PAGE: %s  (1MB)\n\n",
 				mkstring(buf, VADDR_PRLEN, RJUST | LONG_HEX,
-				MKSTR(PAGEBASE(pmd_pte))));
+				MKSTR(sectionbase)));
 		}
-		*paddr = PAGEBASE(pmd_pte) + (vaddr & ~_SECTION_PAGE_MASK);
+		*paddr = sectionbase + (vaddr & ~_SECTION_PAGE_MASK);
 		return TRUE;
 	}
 
-- 
1.7.11.3

